package com.logicbig.example;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.HttpRequestHandler;
import org.springframework.web.servlet.config.annotation.EnableWebMvc;
import org.springframework.web.servlet.config.annotation.InterceptorRegistration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;
import org.springframework.web.servlet.handler.SimpleUrlHandlerMapping;

import java.util.HashMap;
import java.util.Map;

@EnableWebMvc
@Configuration
public class AppConfig extends WebMvcConfigurerAdapter {
    
    @Bean
    public SimpleUrlHandlerMapping simpleUrlHandlerMapping () {
        SimpleUrlHandlerMapping mapping = new SimpleUrlHandlerMapping();
        Map<String, Object> map = new HashMap<>();
        map.put("/app", httpRequestHandler());
        mapping.setUrlMap(map);
        mapping.setInterceptors(new Object[]{new MyInterceptor()});
        return mapping;
    }
    
    @Bean
    HttpRequestHandler httpRequestHandler () {
        return new MyHttpRequestHandler();
    }
    
    @Override
    public void addInterceptors (InterceptorRegistry registry) {
        InterceptorRegistration ir = registry.addInterceptor(new MyInterceptor());
    }
    
    @Bean
    ExampleController controller () {
        return new ExampleController();
    }
}